#!/usr/bin/env ruby


#  Copyright (C) 2006-2007 by Nevil Brownlee,
#  CAIDA | University of Auckland

# ./fix-cpr-date.rb '*.c' 2004 2006
#   Leave out dates to search for Copyright


dir = ARGV[0];  old = ARGV[1];  new = ARGV[2]
oldp = "-#{old}"
newr = "-#{new}"
test = old.nil? || new.nil?

if ARGV.length == 2
   puts "Search #{dir}, look for #{oldp} (make no changes)"
elsif ARGV.length == 3
   puts "Search #{dir}, change #{oldp} to #{newr}"
else
   puts "Wrong number of arguments..\n   fix-c-date.rb '*.c' 2004 2006"
   exit
end


Dir[dir].each { |fn|
   puts "fn=#{fn}"

   if test then ifn = fn
   else
      File.rename(fn, "#{fn}\~")
      out = File.open(fn, "w")
      ifn = "#{fn}\~"
      end

  File.open(ifn) do |file|
      file.each_line { |line|
         if line =~ /Copyright.*Nevil/ || line =~ /display.*Copyright/
            if test then puts line
            else line = line.sub(oldp, newr)
               end
            end
         if !test
            out.puts line 
            end
         }

      end
   }
